> For clean Markdown content of this page, append .md to this URL. For the complete documentation index, see https://learning.postman.com/llms.txt. For full content including API reference and SDK examples, see https://learning.postman.com/llms-full.txt.

# Update a component draft

PATCH https://api.getpostman.com/components/{componentId}/drafts
Content-Type: application/json

Updates a component's draft. Component drafts contain unpublished edits to a component, which may be different from a recently published version.

**Note:**

You can't update archived components.


Reference: https://learning.postman.com/api-docs/api-reference/components/update-component-draft

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Postman API
  version: 1.0.0
paths:
  /components/{componentId}/drafts:
    patch:
      operationId: updateComponentDraft
      summary: Update a component draft
      description: >
        Updates a component's draft. Component drafts contain unpublished edits
        to a component, which may be different from a recently published
        version.


        **Note:**


        You can't update archived components.
      tags:
        - components
      parameters:
        - name: componentId
          in: path
          description: The component's ID.
          required: true
          schema:
            $ref: '#/components/schemas/componentId'
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/updateComponentDraftResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/UpdateComponentDraftRequestUnauthorizedError
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UpdateComponentDraftRequestForbiddenError'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '409':
          description: Conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/UpdateComponentDraftRequestInternalServerError
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/updateComponentDraft'
servers:
  - url: https://api.getpostman.com
    description: https://api.getpostman.com
  - url: https://api.eu.postman.com
    description: https://api.eu.postman.com
components:
  schemas:
    componentId:
      type: string
      description: The component's ID.
      title: componentId
    componentContentFormatData:
      type: string
      enum:
        - JSON
        - YAML
      description: The component's content format.
      title: componentContentFormatData
    updateComponentDraft:
      type: object
      properties:
        content:
          type: string
          description: The component's contents, up to a maximum of 500 KB (UTF-8).
        format:
          $ref: '#/components/schemas/componentContentFormatData'
      description: Information about the component draft.
      title: updateComponentDraft
    updateComponentDraftResponse:
      type: object
      properties:
        id:
          type: string
          description: The component draft's ID.
      description: Information about the component draft.
      title: updateComponentDraftResponse
    CommonErrorTypeTitleDetailStatusType:
      oneOf:
        - type: string
          format: uri-reference
        - type: string
      title: CommonErrorTypeTitleDetailStatusType
    commonErrorTypeTitleDetailStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailStatusType'
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: Information about the error.
        status:
          type: integer
          description: The error's HTTP status code.
      title: commonErrorTypeTitleDetailStatus
    CommonErrorNameMessageError:
      type: object
      properties:
        name:
          type: string
          description: The error name.
        message:
          type: string
          description: The error message.
      description: Information about the error.
      title: CommonErrorNameMessageError
    commonErrorNameMessage:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/CommonErrorNameMessageError'
          description: Information about the error.
      title: commonErrorNameMessage
    UpdateComponentDraftRequestUnauthorizedError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: UpdateComponentDraftRequestUnauthorizedError
    UpdateComponentDraftRequestForbiddenError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: UpdateComponentDraftRequestForbiddenError
    CommonErrorTypeTitleDetailDetail:
      oneOf:
        - type: string
        - type: object
          additionalProperties:
            description: Any type
      description: Information about the error.
      title: CommonErrorTypeTitleDetailDetail
    commonErrorTypeTitleDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailDetail'
          description: Information about the error.
      title: commonErrorTypeTitleDetail
    UpdateComponentDraftRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: UpdateComponentDraftRequestInternalServerError
  securitySchemes:
    PostmanApiKey:
      type: apiKey
      in: header
      name: x-api-key
    scimApiKey:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        A valid [SCIM API
        key](https://learning.postman.com/docs/administration/scim-provisioning/scim-provisioning-overview/#generating-scim-api-key)
        for calls to SCIM endpoints.
    basicAuth:
      type: http
      scheme: basic

```

## Examples

### Component Draft Updated



**Request**

```json
undefined
```

**Response**

```json
{
  "id": "01KT964C30J3DPJQKEACZH39N8"
}
```

**SDK Code**

```python Component Draft Updated
import requests

url = "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts"

headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.patch(url, headers=headers)

print(response.json())
```

```javascript Component Draft Updated
const url = 'https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts';
const options = {
  method: 'PATCH',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Component Draft Updated
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts"

	req, _ := http.NewRequest("PATCH", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Component Draft Updated
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Component Draft Updated
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Component Draft Updated
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts', [
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Component Draft Updated
using RestSharp;

var client = new RestClient("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts");
var request = new RestRequest(Method.PATCH);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Component Draft Updated
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Update Component Draft



**Request**

```json
{
  "content": "openapi: 3.0.0\ninfo:\n  title: Example API\n  version: 1.0.0",
  "format": "YAML"
}
```

**Response**

```json
{
  "id": "01KT964C30J3DPJQKEACZH39N8"
}
```

**SDK Code**

```python Update Component Draft
import requests

url = "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts"

payload = {
    "content": "openapi: 3.0.0
info:
  title: Example API
  version: 1.0.0",
    "format": "YAML"
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript Update Component Draft
const url = 'https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts';
const options = {
  method: 'PATCH',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"content":"openapi: 3.0.0\ninfo:\n  title: Example API\n  version: 1.0.0","format":"YAML"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Update Component Draft
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts"

	payload := strings.NewReader("{\n  \"content\": \"openapi: 3.0.0\\ninfo:\\n  title: Example API\\n  version: 1.0.0\",\n  \"format\": \"YAML\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Update Component Draft
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"content\": \"openapi: 3.0.0\\ninfo:\\n  title: Example API\\n  version: 1.0.0\",\n  \"format\": \"YAML\"\n}"

response = http.request(request)
puts response.read_body
```

```java Update Component Draft
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"content\": \"openapi: 3.0.0\\ninfo:\\n  title: Example API\\n  version: 1.0.0\",\n  \"format\": \"YAML\"\n}")
  .asString();
```

```php Update Component Draft
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts', [
  'body' => '{
  "content": "openapi: 3.0.0\\ninfo:\\n  title: Example API\\n  version: 1.0.0",
  "format": "YAML"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Update Component Draft
using RestSharp;

var client = new RestClient("https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts");
var request = new RestRequest(Method.PATCH);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"content\": \"openapi: 3.0.0\\ninfo:\\n  title: Example API\\n  version: 1.0.0\",\n  \"format\": \"YAML\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Update Component Draft
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "content": "openapi: 3.0.0
info:
  title: Example API
  version: 1.0.0",
  "format": "YAML"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/components/01KT964C30J3DPJQKEACZH39N8/drafts")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```